declare
proc {NaiveDistributor Is}
   {Stabilize}
   local 
      Fs={Filter Is
	  fun {$ I} {FD.reflect.size I}>1 end}
   in 
      case Fs
      of nil then skip 
      [] F|Fr then M={FD.reflect.min F} in 
	 choice F=M   {NaiveDistributor Fr}
	 []     F\=:M {NaiveDistributor Fs}
	 end
      end 
   end 
end


declare
proc {Grocery Root}
   [A B C D] = Root
   S         = 711
in
   Root ::: 0#S
   A*B*C*D =: S*100*100*100
   A+B+C+D =: S
   %% 79 is prime factor of S=711
   A =: 79*{FD.decl}
   %% B =< C =< D
   B =<: C
   C =<: D 
   {NaiveDistributor Root}
end

{ExploreAll Grocery}



declare
proc {SplitDistributor Is}
   {Stabilize}
   local 
      Fs={Filter Is
	  fun {$ I}
	     {FD.reflect.size I}>1
	  end}
   in  
      case Fs  
      of nil then skip 
      [] F|Fr then  
	 MinVar#_ = {FoldL Fr
		     fun {$ Var#Size X}
			case {FD.reflect.size X}<Size
			then 
			   X#{FD.reflect.size X}
			else  
			   Var#Size
			end 
		     end F#{FD.reflect.size F}}
	 Mid = {FD.reflect.mid MinVar}  
      in 
	 choice MinVar =<: Mid
	 then {SplitDistributor Fs}
	 []     MinVar >: Mid
	 then {SplitDistributor Fs}
	 end 
      end 
   end 
end

declare
proc {Grocery Root}
   [A B C D] = Root
   S         = 711
in
   Root ::: 0#S
   A*B*C*D =: S*100*100*100
   A+B+C+D =: S
   %% 79 is prime factor of S=711
   A =: 79*{FD.decl}
   %% B =< C =< D
   B =<: C
   C =<: D 
   {SplitDistributor Root}
end

{ExploreAll Grocery}
