declare 
proc {FourQueens Row}
   L14  = {List.number 1 4 1}      % [1 2 3 4]
   LM1M4 = {List.number ~1 ~4 ~1}  % [~1 ~2 ~3 ~4]
in
   Row = {FD.tuple queens 4 1#4}
   {FD.distinct Row}
   {FD.distinctOffset Row L14}
   {FD.distinctOffset Row LM1M4}
   {FD.distribute generic(order:size value:mid) Row}
end

%% Load graphical Explorer plugin
\feed 'nqueens/graphics.oz'

{ExploreOne FourQueens}


%% Parameterize script over N

declare
fun {Queens N}
   proc {$ Row}
      L1N  = {List.number 1 N 1}   
      LM1N = {List.number ~1 ~N ~1}
   in
      Row = {FD.tuple queens N 1#N}
      {FD.distinct Row}
      {FD.distinctOffset Row L1N}
      {FD.distinctOffset Row LM1N}
      {FD.distribute
       generic(order:size value:mid) Row}
   end
end

{ExploreOne {Queens 33}}

{ExploreOne {Queens 100}}

{ExploreOne {Queens 400}}
