proc {TimetablingDraw _ Solution}

   CanvasWidth   = 720
   WeekDaysWidth = 100
   HourWidth     = CanvasWidth div (TTData.lateNight
				    - TTData.earlyMorning + 2)
   MorningOffset = HourWidth div 2
   CourseHeight  = 20
   NumberOfDays  = {Length TTData.weekDayNames}
   DayHeight     = (TTData.numberOfRooms+1)*CourseHeight
   TopOffset     = 30
   TopNumOffset  = 20
   CanvasHeight  = NumberOfDays*DayHeight+TopOffset*2+CourseHeight
   
   XCourseTextOffset = 10
   YCourseTextOffset = CourseHeight div 2

   Font          =('-*-lucidatypewriter-*-*-*-*-'#
		   CourseHeight#
		   '-*-*-*-*-*-*-*')

   CanvasColor = case Tk.isColor then mediumturquoise else white end

   %% window for schedule
   W = {New Tk.toplevel tkInit(%parent:     Parent
			       background: CanvasColor
			       title: ' Course Timetable ')} 

   %% canvas for the schedule
   Canvas = {New Tk.canvas tkInit(parent:W 
				  width:CanvasWidth
				  height:CanvasHeight)}

   %% canvas for the week days on the left
   WeekDays = {New Tk.canvas tkInit(parent:W
				    width:WeekDaysWidth
				    height:CanvasHeight)}

   {Tk.send pack(WeekDays Canvas side:left)}
   
in

   %% time line on top of window
   
   {Loop.for TTData.earlyMorning TTData.lateNight+1 1
    proc{$ I}
       J=I-TTData.earlyMorning
       Text={Int.toString I}
       X=MorningOffset+J*HourWidth
    in 
       {Canvas tk(crea line X 0 X 10)}
       {Canvas tk(crea text X TopNumOffset text:Text)}
       {Canvas tk(crea line X TopOffset X
		  CourseHeight*(TTData.numberOfRooms+1)*NumberOfDays+
		  TopOffset)}
    end}

   {Record.foldLInd TTData.courses
    fun {$ CourseId I Course}
       EnterTag={New Tk.canvasTag
		 tkInit(parent:Canvas)}
       LeaveTag={New Tk.canvasTag
		 tkInit(parent:Canvas)}
       DeleteTag={New Tk.canvasTag
		  tkInit(parent:Canvas)}
    in
       {Canvas tk(crea rectangle
		  MorningOffset+I*HourWidth
		  CanvasHeight-CourseHeight
		  MorningOffset+(I+1)*HourWidth
		  CanvasHeight
		  fill:TTData.courses.CourseId.color
		  tags:q(EnterTag LeaveTag))}

       {EnterTag tkBind(event: '<Enter>'
			args: nil
			action: proc {$}
				   {ForAll
				    {FD.reflect.domList
				     Solution.courseHours.CourseId}
				    proc {$ CourseHour}
				       XStart=
				       MorningOffset+
				       CourseHour mod
				       (TTData.lateNight
					-TTData.earlyMorning+1)
				       *HourWidth
				       YStart=
				       TopOffset+
				       CourseHour div
				       (TTData.lateNight-
					TTData.earlyMorning+1)
				       *CourseHeight
				       *(TTData.numberOfRooms+1)
				       +TTData.numberOfRooms
				       *CourseHeight
				    in
				       {Canvas tk(crea rectangle
						  XStart YStart
						  XStart+HourWidth
						  YStart+CourseHeight
						  fill:TTData.courses.CourseId.color
						  tags:DeleteTag)}
				    end}
				end)}
       {LeaveTag tkBind(event: '<Leave>'
			args: nil
			action: proc {$}
				   {Canvas tk(delete DeleteTag)}
				end)}
       I+1
    end 0 _}
   
   %% all the rest
   
   {List.forAllInd TTData.weekDayNames
    proc{$ Ind Day}
       %% put the weekday in the weekday canvas
       {WeekDays tk(crea text 5
		    Ind*DayHeight-(DayHeight div 2)+TopOffset
		    text:Day anchor:w)}
       %% make a line where the day starts
       YStartOfDay=TopOffset+(Ind-1)*DayHeight
       {Canvas tk(crea line 0 YStartOfDay
		  CanvasWidth YStartOfDay)}
       
       CoursesOnThatDay = {Record.foldRInd Solution.courseHours
			   fun {$ I CourseHour Acc}
			      case
				 {IsDet CourseHour}
				 andthen
				 {FD.reified.int
				  Solution.weekDays.Day
				  CourseHour} == 1
			      then
				 course(courseId:I
					courseHour:CourseHour
					hour:CourseHour-Solution
					.weekDays.Day.1)
				 |Acc
			      else
				 Acc
			      end
			   end nil}

       SortedCourses = {Sort CoursesOnThatDay
			fun {$ C1 C2}
			   C1.courseHour < C2.courseHour
			   orelse
			   (C1.courseHour == C2.courseHour
			    andthen
			    C1.courseId < C2.courseId)
			end}
    in
       %% display all courses of that day
       {List.foldL SortedCourses
	fun {$ Row#Hour course(courseId:I courseHour:_ hour:NewHour)}
	   NewRow=case Hour==NewHour then Row + 1
		  else 0 end
	   XStart=MorningOffset+NewHour*HourWidth
	   YStart=YStartOfDay+NewRow*CourseHeight
	in
	   {Canvas tk(crea rectangle XStart YStart
		      XStart+HourWidth YStart+CourseHeight
		      fill:TTData.courses.I.color)}
	   {Canvas tk(crea text
		      XStart+XCourseTextOffset
		      YStart+YCourseTextOffset
		      text:I
		      anchor:w
%		      font:Font
		     )}
	   NewRow#NewHour
	end
	0#~1 _}
    end}
end
